<mat-horizontal-stepper [linear]="false" #stepper>
  <mat-step>
    <form [formGroup]="POCreationFormGroup" #poForm="ngForm">
      <ng-template matStepLabel>PO Creation</ng-template>
      <mat-form-field>
        <mat-label>Supplier</mat-label>
        <i class="fa fa-caret-down" aria-hidden="true"></i>
        <input type="text" placeholder="Supplier" matInput [formControl]="supplier" formControlName="supplier"
          [matAutocomplete]="auto1">
        <mat-autocomplete #auto1="matAutocomplete">
          <mat-option class="auto-cmplt" *ngFor="let supplierId of filteredSuppliers | async"
            (click)="updateSelect('POCreationFormGroup', 'supplier', supplierId.bpCode+ '-' + supplierId.name, supplierId.currency, supplierId)"
            [value]="supplierId.name">
            {{supplierId.bpCode}} - {{supplierId.name}}
          </mat-option>
        </mat-autocomplete>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Warehouse</mat-label>
        <mat-select name="warehouse" formControlName="warehouse">
          <mat-option *ngFor="let warehouse of wareHouses" [value]="warehouse.code" >
          <!-- (click)="getItemDetails(warehouse.code)" -->
            {{warehouse.code}} - {{warehouse.description}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Drafted Purchase Orders</mat-label>
        <mat-select name="draftedOrder" formControlName="draftedOrder">
          <mat-option (click)="updateDraftedOrder('')">Select</mat-option>
          <mat-option *ngFor="let draftedOrder of draftedOrders" [value]="draftedOrder.purchaseOrder"
            (click)="updateDraftedOrder(draftedOrder)">
            {{draftedOrder.purchaseOrder}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Currency</mat-label>
        <i class="fa fa-caret-down" aria-hidden="true"></i>
        <input type="text" placeholder="Currency" matInput [formControl]="currency" formControlName="currency"
          [matAutocomplete]="auto">
        <mat-autocomplete #auto="matAutocomplete">
          <mat-option *ngFor="let currency of filteredCurrencies | async" [value]="currency"
            (click)="updateSelect('POCreationFormGroup', 'currency', currency, null)">
            {{currency}}
          </mat-option>
        </mat-autocomplete>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Terms of Payment</mat-label>
        <mat-select name="paymentTerm" formControlName="paymentTerm">
          <mat-option *ngFor="let paymentTerm of paymentTerms" [value]="paymentTerm">
            {{paymentTerm}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Estimated Receipt Date</mat-label>
        <input matInput readonly [matDatepicker]="datepicker" formControlName="estimatedDeliveryDate" />
        <mat-datepicker-toggle matSuffix [for]="datepicker"></mat-datepicker-toggle>
        <mat-datepicker #datepicker></mat-datepicker>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Purchase Order Date</mat-label>
        <input matInput readonly [matDatepicker]="creationDate" formControlName="creationDate" />
        <mat-datepicker-toggle matSuffix [for]="creationDate"></mat-datepicker-toggle>
        <mat-datepicker #creationDate></mat-datepicker>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Comments</mat-label>
        <textarea matInput placeholder="Comments" rows="1" maxlength="150" formControlName="notes"></textarea>
      </mat-form-field>
      <section class="po-list">
        <ul>
          <li *ngFor="let item of itemsArr.controls; let i = index" [formGroup]="item">
            <span class="s-no">{{i+1}}</span>
            <mat-form-field>
              <mat-label>Item Code</mat-label>
              <i class="fa fa-caret-down" aria-hidden="true"></i>
              <input type="text" placeholder="Item Code" matInput formControlName="itemCode" [matAutocomplete]="auto2">
              <mat-autocomplete #auto2="matAutocomplete" [displayWith]="displayItemId">
                <mat-option *ngFor="let item of observers[i] | async" [value]="item.item.itemCode"
                  (click)="updateItemDetails($event, i, item)">
                  {{item.item.itemCode}} - {{item.item.description}}
                </mat-option>
              </mat-autocomplete>
            </mat-form-field>
            <mat-form-field>
              <mat-label>Item Description</mat-label>
              <input matInput placeholder="Item Description" formControlName="itemDescription" required disabled>
            </mat-form-field>
            <mat-form-field>
              <mat-label>Available Quantity</mat-label>
              <input matInput placeholder="Available Quantity" formControlName="availableQuantity" required disabled="true">
            </mat-form-field>
            <mat-form-field>
              <mat-label>Quantity</mat-label>
              <input type="number" matInput placeholder="Quantity" (keyup)="updateAmount(i)" formControlName="quantity"
                required autocomplete="off">
            </mat-form-field>

            <mat-form-field>
              <mat-label>Unit</mat-label>
              <input type="text" matInput placeholder="unit" formControlName="unit" required disabled>
            </mat-form-field>

            <mat-form-field>
              <mat-label>Price</mat-label>
              <input type="number" matInput (keyup)="updateAmount(i)" (blur)="checkPrice(i)" placeholder="Price"
                formControlName="price" required>
            </mat-form-field>
            <mat-form-field>
              <mat-label>Discount %</mat-label>
              <input type="number" matInput (keyup)="updateAmount(i)" placeholder="Discount Percentage"
                formControlName="discountPercentage" required>
            </mat-form-field>
            <mat-form-field>
              <mat-label>Sub Total</mat-label>
              <input matInput placeholder="Sub Total" formControlName="subTotal" required disabled>
            </mat-form-field>
            <mat-form-field>
              <mat-label>VAT Code</mat-label>
              <mat-select name="vatCode" formControlName="vatCode">
                <mat-option *ngFor="let vat of vatCodes" [value]="vat.vatCode" (click)="updateVat(i, vat.vatPercentage)">
                  {{vat.vatCode}} - {{vat.vatDescription}}
                </mat-option>
              </mat-select>
            </mat-form-field>
            <mat-form-field>
              <mat-label>VAT %</mat-label>
              <input matInput placeholder="VAT Percentage " (keyup)="updateAmount(i)" formControlName="vatPercentage" required>
            </mat-form-field>
            <mat-form-field>
              <mat-label>Total Price</mat-label>
              <input matInput placeholder="Total Price" formControlName="totalprice" required disabled>
            </mat-form-field>
            <div class="button-item">
              <!-- <button mat-mini-fab class="add-remove-item add" (click)="addItem(i, item)">+</button> -->
              <button mat-mini-fab class="add-remove-item remove" (click)="deleteDialog(i, item)">-</button>
            </div>
          </li>
        </ul>
      </section>
      <div class="button-item-add">
        <span><button mat-mini-fab class="add-remove-item add" (click)="addItem()">+</button></span> <span
          class="text-btn">Add Items</span>
      </div>
      <section *ngIf="itemsArr.controls.length > 0" class="summary-container">
        <h5>Summary</h5>
        <mat-list>
          <mat-list-item>
            <div class="summary-item">
              <span class="key">Total Amount: </span>
              <span class="value">{{poSummary.totalAmount | number : '1.0-2'}}</span>
            </div>
            <div class="summary-item">
              <span class="key">Discount Amount: </span>
              <span class="value">{{poSummary.discountAmount | number : '1.0-2'}}</span>
            </div>
            <div class="summary-item">
              <span class="key">Total Excl. VAT: </span>
              <span class="value">{{poSummary.subTotal | number : '1.0-2'}}</span>
            </div>
            <div class="summary-item">
              <span class="key">VAT Amount: </span>
              <span class="value">{{poSummary.vatAmount | number : '1.0-2'}}</span>
            </div>
            <div class="summary-item">
              <span class="key">Total Incl. VAT: </span>
              <span class="value">{{poSummary.amount | number : '1.0-2'}}</span>
            </div>
            <div class="summary-item" *ngIf="POCreationFormGroup.controls['currency'].value !== 'SAR-Saudi riyal' && POCreationFormGroup.controls['currency'].value !== ''">
              <span class="key">Total Excl. VAT in SAR: </span>
              <span class="value">{{poSummary.subTotalInSAR | number : '1.0-2'}}</span>
            </div>
            <div class="summary-item" *ngIf="POCreationFormGroup.controls['currency'].value !== 'SAR-Saudi riyal' && POCreationFormGroup.controls['currency'].value !== ''">
              <span class="key">Total Incl. VAT in SAR: </span>
              <span class="value">{{poSummary.amountInSAR | number : '1.0-2'}}</span>
            </div>
          </mat-list-item>
        </mat-list>
      </section>
      <div class="po-btn">
        <button class="save-btn" mat-button [disabled]="!POCreationFormGroup.valid"
          (click)="submitInvoice('save')">Save</button>
        <button mat-button [disabled]="!POCreationFormGroup.valid" (click)="submitInvoice('submit')">Submit</button>
      </div>
    </form>
  </mat-step>
  <mat-step>
    <form [formGroup]="materialReceivingFormGroup" #mrForm="ngForm">
      <ng-template matStepLabel>Material Receiving</ng-template>
          <mat-form-field>
            <mat-label>PO Number</mat-label>
            <mat-select name="poNumber" formControlName="poNumber">
              <mat-option *ngFor="let poNumber of poNumbers" [value]="poNumber.purchaseOrder"
                (click)="updatePODetails(poNumber)">
                {{poNumber.purchaseOrder}}
              </mat-option>
            </mat-select>
          </mat-form-field>
          <mat-form-field>
            <mat-label>Supplier</mat-label>
            <mat-select name="supplier" formControlName="supplier">
              <mat-option *ngFor="let supplier of poNumbers" [value]="supplier.supplier" [attr.disabled]='true'>
                {{supplier.supplier}} - {{supplier.supplierName}}
              </mat-option>
            </mat-select>
          </mat-form-field>
          <mat-form-field>
            <mat-label>Warehouse</mat-label>
            <input type="text" matInput placeholder="Warehouse" formControlName="warehouse" required [attr.disabled]='true'>
          </mat-form-field>
          <mat-form-field>
            <mat-label>Currency</mat-label>
            <mat-select name="currency" formControlName="currency">
              <mat-option *ngFor="let currency of currencies" [value]="currency" [attr.disabled]='true'>
                {{currency}}
              </mat-option>
            </mat-select>
          </mat-form-field>
          <mat-form-field>
            <mat-label>Packing Slip Number</mat-label>
            <input type="text" matInput placeholder="Packing Slip Number" formControlName="packingSlipNumber" required>
          </mat-form-field>
          <div class="mat-elevation-z8 MS-Items" *ngIf='ELEMENT_DATA && ELEMENT_DATA.length > 0'>
            <table mat-table matSort [dataSource]="dataSource">
              <!-- Checkbox Column -->
              <ng-container matColumnDef="select">
                <th mat-header-cell *matHeaderCellDef>
                  <mat-checkbox (change)="$event ? masterToggle() : null"
                    [checked]="selection.hasValue() && isAllSelected()"
                    [indeterminate]="selection.hasValue() && !isAllSelected()" [aria-label]="checkboxLabel()">
                  </mat-checkbox>
                </th>
                <td mat-cell *matCellDef="let row">
                  <mat-checkbox (click)="$event.stopPropagation()" (change)="updateAmountMR($event, row);"
                    [checked]="selection.isSelected(row)" [aria-label]="checkboxLabel(row)">
                  </mat-checkbox>
                </td>
              </ng-container>
              <ng-container matColumnDef="S no">
                <th mat-header-cell *matHeaderCellDef> S No </th>
                <td class="link" mat-cell *matCellDef="let element; let i = index;"> {{i + 1}}</td>
              </ng-container>
              <!-- code Column -->
              <ng-container matColumnDef="Item Code">

                <th mat-header-cell *matHeaderCellDef mat-sort-header> Item Code </th>
                <td class="link" mat-cell *matCellDef="let element"> {{element.itemCode}} </td>
              </ng-container>

              <!-- name Column -->
              <ng-container matColumnDef="Description">
                <th mat-header-cell *matHeaderCellDef> Item Description </th>
                <td mat-cell *matCellDef="let element"> {{element.itemDescription}} </td>
              </ng-container>

              <ng-container matColumnDef="Quantity">
                <th mat-header-cell *matHeaderCellDef> Quantity </th>

                <td mat-cell *matCellDef="let element; let i = index; let row"> {{element.remainingQuantity}} <span
                    *ngIf="element.remainingQuantity !== '0' && selection.isSelected(row)" class="update-qty"
                    (click)="updateQty(element, i)">change</span></td>
              </ng-container>

              <ng-container matColumnDef="Unit">
                <th mat-header-cell *matHeaderCellDef> Unit </th>
                <td mat-cell *matCellDef="let element"> {{element.unit}} </td>
              </ng-container>
              <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
              <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
            </table>
            <div class="asset-list" *ngIf="fixedAssetArr.controls.length > 0">
              <mat-list role="list">
                <mat-list-item *ngFor="let item of fixedAssetArr.controls; let i = index" [formGroup]="item">
                  <mat-form-field>
                    <mat-label>Item Code</mat-label>
                    <input matInput placeholder="Item Code" formControlName="itemCode" required disabled>
                  </mat-form-field>
                  <mat-form-field>
                    <mat-label>Fixed Asset Code</mat-label>
                    <mat-select name="assetCode" formControlName="assetCode">
                      <mat-option *ngFor="let asset of assetCodes" [value]="asset.assetCode">
                        {{asset.assetCode}} - {{asset.assetName}}
                      </mat-option>
                    </mat-select>
                  </mat-form-field>
                </mat-list-item>
              </mat-list>
            </div>
          </div>
      <div class="button-container">
        <button class="save-btn" mat-button matStepperPrevious>Back</button>
        <button mat-button (click)="submitMSForm()"
          [disabled]="!materialReceivingFormGroup.valid || selection.selected.length === 0">Submit</button>
      </div>
    </form>
  </mat-step>
  <mat-step>
    <form [formGroup]="materialReceivingFormGroupTwo" #mrTwoForm="ngForm">
      <ng-template matStepLabel>Invoice Booking</ng-template>
      <mat-form-field>
        <mat-label>Supplier</mat-label>
        <i class="fa fa-caret-down" aria-hidden="true"></i>
        <input type="text" placeholder="Supplier" matInput [formControl]="supplier2" formControlName="supplier"
          [matAutocomplete]="auto2">
        <mat-autocomplete #auto2="matAutocomplete">
          <mat-option class="auto-cmplt" *ngFor="let supplierId of filteredSuppliers2 | async"
            (click)="updatePOFilter('materialReceivingFormGroupTwo', 'supplier', supplierId.bpCode+ '-' + supplierId.name)"
            [value]="supplierId.name">
            {{supplierId.bpCode}} - {{supplierId.name}}
          </mat-option>
        </mat-autocomplete>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Select Purchase Order</mat-label>
        <mat-select name="poCode" formControlName="pOrder">
          <mat-option *ngFor="let poCode of poCodes" [value]="poCode" (click)="updateMRFilter(poCode)">
            {{poCode}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Select MR Code</mat-label>
        <mat-select name="mrCode" formControlName="referenceOrder" multiple>
          <mat-option *ngFor="let mrCode of mrCodes" [value]="mrCode.code" (onSelectionChange)="updateInvoiceDetails($event, mrCode)">
            {{mrCode.code}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Invoice Number</mat-label>
        <input type="text" matInput placeholder="Invoice Number" formControlName="invoiceNumber" required>
      </mat-form-field>
      <mat-form-field>
        <mat-label>VAT Amount</mat-label>
        <input type="number" matInput placeholder="VAT Amount" formControlName="vatAmount" required>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Invoice Amount</mat-label>
        <input type="number" matInput placeholder="Invoice Amount" formControlName="invoiceAmount" required>
        <span class="custom-error" *ngIf="materialReceivingFormGroupTwo.controls['invoiceAmount'].value > materialReceivingFormGroupTwo.controls['setAmount'].value">
          The entered amount is greater than receipt amount.
        </span>
        <span class="custom-error" *ngIf="materialReceivingFormGroupTwo.controls['invoiceAmount'].value < materialReceivingFormGroupTwo.controls['setAmount'].value">
          The entered amount is less than receipt amount.
        </span>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Invoice Date</mat-label>
        <input matInput readonly [matDatepicker]="picker" formControlName="invoiceDate">
        <mat-datepicker-toggle matSuffix [for]="picker"></mat-datepicker-toggle>
        <mat-datepicker #picker></mat-datepicker>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Currency</mat-label>
        <mat-select name="currency" formControlName="invoiceCurrency">
          <mat-option *ngFor="let currency of currencies" [value]="currency">
            {{currency}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Comments</mat-label>
        <textarea matInput placeholder="Comments" rows="1" formControlName="notes"></textarea>
      </mat-form-field>
    </form>
    <div class="button-container">
      <button class="save-btn" mat-button matStepperPrevious>Back</button>
      <button mat-button [disabled]="!materialReceivingFormGroupTwo.valid " (click)="submitMSInvoice()">Submit</button>
    </div>
  </mat-step>
  <mat-step>
    <form [formGroup]="paymentFormGroup" #paymentForm="ngForm">
      <ng-template matStepLabel>Payment</ng-template>
      <mat-form-field>
        <mat-label>Supplier</mat-label>
        <mat-select name="supplier" formControlName="supplier">
          <mat-option *ngFor="let supplier of supliers" [value]="supplier.bpCode"
            (click)="updatePo(supplier)">
            {{supplier.bpCode}} - {{supplier.name}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Bank Name</mat-label>
        <mat-select name="bankName" formControlName="bankName">
          <mat-option *ngFor="let bank of availableBanks" [value]="bank">
            {{bank}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Transaction Entry Date</mat-label>
        <input matInput readonly [matDatepicker]="picker1" formControlName="transactionEntryDate">
        <mat-datepicker-toggle matSuffix [for]="picker1"></mat-datepicker-toggle>
        <mat-datepicker #picker1></mat-datepicker>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Document Date</mat-label>
        <input matInput readonly [matDatepicker]="picker2" formControlName="documentDate">
        <mat-datepicker-toggle matSuffix [for]="picker2"></mat-datepicker-toggle>
        <mat-datepicker #picker2></mat-datepicker>
      </mat-form-field>
      <mat-form-field>
          <mat-label>Document Number</mat-label>
          <input type="text" matInput placeholder="Document Number" formControlName="documentNumber">
      </mat-form-field>
      <mat-form-field>
        <mat-label>Type Of Transaction</mat-label>
        <mat-select name="typeOfTransaction" formControlName="typeOfTransaction">
          <mat-option *ngFor="let transaction of typesOfTransactions" [value]="transaction" (click)="checkVat(transaction)">
            {{transaction}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Select Invoice Number</mat-label>
        <mat-select name="invoiceBookings" formControlName="invoiceBookings" multiple>
          <mat-option *ngFor="let invoiceBooking of invoiceBookings" [value]="invoiceBooking.invoiceNumber"
            (onSelectionChange)="updateItemsPayAmount($event, invoiceBooking)">
            {{invoiceBooking.invoiceNumber}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Currency</mat-label>
        <mat-select name="currency" formControlName="currency">
          <mat-option *ngFor="let currency of currencies" [value]="currency">
            {{currency}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field *ngIf="showPoNum">
        <mat-label>PO Number</mat-label>
        <input type="text" matInput placeholder="PO Number" 
          formControlName="poNumber" required>
      </mat-form-field>
      <div class='paymentList'>
        <mat-list role="list">
          <mat-list-item *ngFor="let item of amountArr.controls; let i = index" [formGroup]="item">
            <mat-form-field>
              <mat-label>Purchase order Code</mat-label>
              <input type="text" matInput placeholder="Material Recieved Code" formControlName="selectedPoNumber"
                required disabled>
            </mat-form-field>
            <mat-form-field>
              <mat-label>Material Received Code</mat-label>
              <input type="text" matInput placeholder="Material Received Code" formControlName="materialReceived" required disabled>
            </mat-form-field>
            <mat-form-field>
              <mat-label>Amount</mat-label>
              <input type="number" matInput placeholder="Amount" (keyup)="updateTotalPayAmount(i)"
                formControlName="totalprice" required disabled>
            </mat-form-field>
          </mat-list-item>
        </mat-list>
      </div>
      <mat-form-field>
        <mat-label>VAT Code</mat-label>
        <mat-select name="vatCode" formControlName="vatCode">
          <mat-option *ngFor="let vat of vatCodes" [value]="vat.vatCode" (click)="updateVatPayment(vat.vatPercentage)">
            {{vat.vatCode}} - {{vat.vatDescription}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>VAT %</mat-label>
        <input matInput placeholder="VAT Percentage " (keyup)="updateAmountPayment($event)" formControlName="vatPercentage" >
      </mat-form-field>
      <mat-form-field>
        <mat-label>Gross Amount</mat-label>
        <input matInput placeholder="Gross Amount " (keyup)="updateAmountPaymentGross($event)" formControlName="grossamt" required>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Net Amount</mat-label>
        <input matInput type="number" placeholder="Net Amount" formControlName="grandtotalprice"
          required disabled>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Comments</mat-label>
        <textarea matInput placeholder="Comments" rows="1" formControlName="notes"></textarea>
      </mat-form-field>
      <div class="button-container">
        <button class="save-btn" mat-button matStepperPrevious>Back</button>
        <button mat-button [disabled]="!paymentFormGroup.valid" (click)="submitPayment()">Submit Payment</button>
      </div>
    </form>
  </mat-step>
</mat-horizontal-stepper>
